using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfLINQ2Nordwind
{
    /// <summary>
    /// Interaktionslogik für wdNWBestellungen.xaml
    /// </summary>
    public partial class wdNWBestellungen : Window
    {
        NordwindDataContext dcNordwind = new NordwindDataContext();

        public wdNWBestellungen()
        {
            InitializeComponent();

            System.Data.Linq.Table<Customers> tbKunden = dcNordwind.GetTable<Customers>();

            var quStaaten = from Kunde in tbKunden select Kunde.Country;

            quStaaten = quStaaten.Distinct();

            foreach (var objStaat in quStaaten)
            {
                TreeViewItem triStaat = new TreeViewItem();
                triStaat.Header = objStaat;
                triStaat.Items.Add("Dummy");
                trvLaender.Items.Add(triStaat);
                triStaat.AddHandler(TreeViewItem.ExpandedEvent, new RoutedEventHandler(OnStaatExpand));
            }
        }

        /// <summary>
        /// Wird ausgelöst, wenn der Benutzer einen Staat-Knoten expandiert
        /// </summary>
        void OnStaatExpand(Object sender, RoutedEventArgs e)
        {
            TreeViewItem triStaat = (TreeViewItem)sender;

            if (triStaat.Items.Count > 0)
            {
                triStaat.Items.Clear();
            }

            System.Data.Linq.Table<Customers> tbKunden = dcNordwind.GetTable<Customers>();
            var quKunden = from Kunde in tbKunden where Kunde.Country == triStaat.Header.ToString() select Kunde;
            quKunden = quKunden.Distinct();

            foreach (var objKunde in quKunden)
            {
                TreeViewItem triKunde = new TreeViewItem();
                triKunde.Header = objKunde.CompanyName;
                triKunde.Tag = objKunde.CustomerID;
                triKunde.AddHandler(TreeViewItem.SelectedEvent, new RoutedEventHandler(OnKundeSelected));
                triStaat.Items.Add(triKunde);
            }
        }

        /// <summary>
        /// Wird ausgelöst, wenn der Benutzer einen Kunde-Knoten auswählt
        /// </summary>
        void OnKundeSelected(object sender, RoutedEventArgs e)
        {
            if (cbxBestellNummer.Items.Count > 0)
            {
                cbxBestellNummer.Items.Clear();
            }

            System.Data.Linq.Table<Orders> tbBestellungen = dcNordwind.GetTable<Orders>();
            var quBestellungen = from Bestellungen in tbBestellungen where Bestellungen.CustomerID == ((TreeViewItem)sender).Tag.ToString() select Bestellungen;

            foreach (var objBestellung in quBestellungen)
            {
                cbxBestellNummer.Items.Add(objBestellung.OrderID);
            }
            cbxBestellNummer.SelectedIndex = 0;
        }

        private void cbxBestellNummer_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            System.Data.Linq.Table<Order_Details> tbDetails = dcNordwind.GetTable<Order_Details>();
            System.Data.Linq.Table<Products> tbProdukte = dcNordwind.GetTable<Products>();

            var quDetails = from Details in tbDetails
                            join Produkte in tbProdukte on Details.ProductID equals Produkte.ProductID
                            where Details.OrderID == Convert.ToInt32(cbxBestellNummer.SelectedItem)
                            select new { BestNr = Details.OrderID, Anz = Details.Quantity, Bez = Produkte.ProductName };

            dgProdukte.ItemsSource = quDetails;
        }
    }
}
